""" Copyright start
  Copyright (C) 2008 - 2024 Fortinet Inc.
  All rights reserved.
  FORTINET CONFIDENTIAL & FORTINET PROPRIETARY SOURCE CODE
  Copyright end """

import os
FRAMEWORK_PATH = os.path.dirname(os.path.abspath(__file__))
REPORT_FILE = f"/{FRAMEWORK_PATH}/outputs/report-{{}}.json"
STEP_RESULT_FILE = f"/{FRAMEWORK_PATH}/outputs/step_result-{{}}.json"
CHECK_READINESS_STATUS_FILE = f"/{FRAMEWORK_PATH}/.check_readiness_status"
EXECUTE_PHASE_STATUS_FILE = f"/{FRAMEWORK_PATH}/.execute_phase_status"
EXECUTE_STATUS_FILE = f"/{FRAMEWORK_PATH}/.execute_status"
CONFIG_FILES_PROPERTIES = [f"{FRAMEWORK_PATH}/config/logger.conf"]
CONFIG_FILES_YAML = ['/opt/cyops/configs/fsr-elevate/config.yml']
LOG_FILE = '/var/log/cyops/fsr-elevate/fsr-elevate.log'
REPO_URL = 'repo.fortisoar.fortinet.com'
REPO_PATH = 'https://{}/{}/elevate/elevate-{}.zip'
CHECKSUM_PATH = 'https://{}/{}/elevate/elevate-{}-checksum.txt'
MODULE_TO_IMPORT = 'workflow.{}.{}'
VERSION_FILE = '/opt/cyops-api/public/version.json'
TASK_TEMPLATE_PATH = '{}/templates/task_file_template.json'
SCRIPT_TEMPLATE_PATH = '{}/templates/shell_file_template.json'
PHASE_ARGUMENT = ['preupgrade', 'postupgrade']
LIST_PHASES = ['preupgrade',
               'upgrade', 'postupgrade']
PHASE_MAP_DICT = {'preupgrade': 'pre_upgrade',
                  'upgrade': 'upgrade', 'postupgrade': 'post_upgrade'}
UNWANTED_FILES_DIR = ['DS_Store', 'MACOSX']
HTTPS_STATUS_CODES = {200: "The requested file {} was found OK",
                      404: "The requested file {} was not found",
                      500: "Server error requesting the file {}"}
VERSION_PATTERN = r'^\d+(\.\d+){2}$'
VERSION_NON_NUMERIC_NON_DOT_CHECK_PATTERN = r'[^0-9.]'
CHECK_READINESS_PHASES = ['preupgrade']
PHASE_DIR_NOT_EXISTS = "{} phase directory does not exists."
PASCAL_CASE_PATTERN = r'^([A-Z][a-zA-Z0-9]*)+$'
TASK_FILE_NAME_PATTERN = r'^\d+_[a-z0-9_]*$'
SNAKE_CASE_PATTERN = r'^[a-z0-9_]+$'
NO_RETRIGGER_COMMANDS = ["check-readiness", "execute-phase", "execute"]
MSG_WIDTH = 80
SPACE_BEFORE_MSG = 2
HTTPS_STATUS_CODE_AND_MESSAGES = {400 : "Https status code : 400 Bad Request", 401 : "Https status code : 401 Unauthorized", 403 : "Https status code : 403 Forbidden", 404 : "Https status code : 404 Not Found", 503 : "Https status code : 503 Bad Gateway"}
UPGRADE_LOG_FILE = "/var/log/cyops/upgrade-fortisoar-{}-{}-{}.log"