Name: %{pkg_name}
Prefix: /opt/fsr-elevate/elevate
Version: %{_version}
Release: %{build_number}%{dist}
License : Commercial
Vendor : Fortinet
Packager: devops-fortisoar@fortinet.com
URL: https://www.fortinet.com
AutoProv: no
AutoReq: no
BuildRoot: %{_tmppath}/%{name}-root
Source: %{name}-%{version}-%{build_number}.tar.gz

%define user `whoami`
%define venv_cmd /usr/bin/python3.9 -m venv --symlinks --system-site-packages
%define venv_name .env
%define venv_install_dir /opt/fsr-elevate/elevate/%{venv_name}
%define venv_dir %{buildroot}%{venv_install_dir}
%define venv_bin %{venv_dir}/bin
%define venv_python %{venv_bin}/python3
%define venv_pip %{venv_bin}/pip3 install --no-cache-dir --force-reinstall

Requires: python3, python3-pip, jq

Summary: FortiSOAR Fsr-elevate Package

%description
FortiSOAR Fsr-elevate Package

%prep
%setup -q -n %{name}-%{version}-%{build_number}

%install
echo "install"
rm -rf %{buildroot}/*

%{venv_cmd} %{venv_dir}
%{venv_python} %{venv_bin}/pip3 install --upgrade pip==21.3.1
rm -f %{buildroot}/opt/%{name}/.env/bin/activate.xsh
export TMPDIR=./tmp
%{venv_pip} six
%{venv_pip} -r requirements.txt
rm -rf ./tmp
venvctrl-relocate --source=%{venv_dir} --destination=%{venv_install_dir}

mkdir -p %{buildroot}%{prefix}
cp -R config %{buildroot}%{prefix}/
cp -R framework %{buildroot}%{prefix}/
cp -R helpers %{buildroot}%{prefix}/
cp -R outputs %{buildroot}%{prefix}/
cp -R rpm %{buildroot}%{prefix}/
cp -R templates %{buildroot}%{prefix}/
cp -R workflow %{buildroot}%{prefix}/
cp -R constants.py %{buildroot}%{prefix}/
cp -R main.py %{buildroot}%{prefix}/
cp -R requirements.txt %{buildroot}%{prefix}/

# Removing all tasks from workflow dir
rm -rf %{buildroot}%{prefix}/workflow/*

cp -R rpm/configs/* %{buildroot}/

# Adding the exit 0 to avoid check-buildroot check
# The check fails and unable to find the cause as of now
# The check fails(as it tries to compile .py files) and unable to find the cause as of now
exit 0

%clean

%pre
mkdir -p %{install_log_dir}
{
    set -x
    echo "Date: `date`"
    echo "%{name}: pre"
    echo "============================================"

    mkdir -p /var/log/cyops/fsr-elevate/
    chown nginx:nginx -R /var/log/cyops/fsr-elevate
    setsebool -P httpd_can_network_connect on
    semanage fcontext -a -s system_u -t httpd_sys_content_t     "/opt/fsr-elevate(/.*)?"

    # Set httpd_log_t context on the logs which are written by nginx, else nginx won't start
    semanage fcontext -a -s system_u -t httpd_log_t             "/var/log/cyops/fsr-elevate(/.*)?"
    # last_system_publish need sys_rw as it is written from bash
    semanage fcontext -a -s system_u -t httpd_sys_rw_content_t  "/var/log/cyops/fsr-elevate/fsr-elevate.log"

    if [ $1 = 1 ]; then
        # Write pre install actions here
        echo "fsr-elevate installation"
    elif [ $1 -gt 1 ]; then
        # Write pre upgrade actions here
        echo "fsr-elevate update"
    fi

} >> %{install_log_dir}/%{install_log_file} 2>&1
# %pre ends here

%files
%defattr(644,nginx,nginx,755)
%dir /opt/%{name}/elevate
/opt/%{name}/elevate/.env
%attr(0755,nginx,nginx) /opt/%{name}/elevate/.env/bin/*
/opt/%{name}/elevate/config
/opt/%{name}/elevate/framework
/opt/%{name}/elevate/helpers
/opt/%{name}/elevate/outputs
/opt/%{name}/elevate/rpm
/opt/%{name}/elevate/templates
/opt/%{name}/elevate/workflow
/opt/%{name}/elevate/constants.py
/opt/%{name}/elevate/main.py
/opt/%{name}/elevate/requirements.txt

%defattr(755,nginx,nginx)
%dir %attr(755,nginx,nginx) /var/log/cyops/%{name}/
%attr(644,nginx,nginx) /var/log/cyops/%{name}/*
%config(noreplace) %attr(644,nginx,nginx) /var/log/cyops/fsr-elevate/fsr-elevate.log
%config(noreplace) %attr(644,nginx,nginx) /opt/cyops/configs/fsr-elevate/config.yml